<?php 
require_once("Models/TTipoPago.php"); 
require_once("Models/TProducto.php");
require_once("Models/TCategoria.php");
class Ventas extends Controllers{
	use TTipoPago, TProducto, TCategoria;
	public function __construct()
	{
		parent::__construct();
		session_start();
		if(empty($_SESSION['login']))
		{
			header('Location: '.base_url().'/login');
			die();
		}
		getPermisos(MVENTAS);
	}

	public function Ventas()
	{
		// if(empty($_SESSION['permisosMod']['r'])){
		// 	header("Location:".base_url().'/dashboard');
		// }
		$data['page_tag'] = "Ventas";
		$data['page_title'] = "Crear Venta";
		$data['page_name'] = "ventas";
		//$data['productos'] = $this->getProductosT();
		$pagina = 1;
		$cantProductos = $this->cantProductos();
		$total_registro = $cantProductos['total_registro'];
		$desde = ($pagina-1) * PROPORPAGINA;
		$total_paginas = ceil($total_registro / PROPORPAGINA);
		$data['productos'] = $this->getProductosPage($desde,PROPORPAGINA);
		$data['pagina'] = $pagina;
		$data['total_paginas'] = $total_paginas;
		$data['categorias'] = $this->getCategorias();
		$data['page_functions_js'] = "functions_ventas.js";
		$this->views->getView($this,"ventas",$data);
	}


	public function getSelectClientes(){
		$htmlOptions = "";
		$arrData = $this->model->selectClientes();
		if(count($arrData) > 0 ){
			for ($i=0; $i < count($arrData); $i++) { 
				if($arrData[$i]['status'] == 1 ){
				$htmlOptions .= '<option value="'.$arrData[$i]['idpersona'].'">'.$arrData[$i]['nombres'].' '.$arrData[$i]['apellidos'].'</option>';
				}
			}
		}
		echo $htmlOptions;
		die();	
	}

	public function getProductos(){
		if($_SESSION['permisosMod']['r']){
			$arrData = $this->model->selectProducto();
			for ($i=0; $i < count($arrData); $i++) {
				$btnEdit = '';
				if($arrData[$i]['status'] == 1)
				{
					$arrData[$i]['status'] = '<span class="badge badge-success">Activo</span>';
				}else{
					$arrData[$i]['status'] = '<span class="badge badge-danger">Inactivo</span>';
				}
				$arrData[$i]['precio'] = SMONEY.' '.formatMoney($arrData[$i]['precio']);
				if($_SESSION['permisosMod']['r']){
					$btnView = '<button class="btn btn-info btn-sm" onClick="fntViewInfo('.$arrData[$i]['idproducto'].')" title="Ver producto"><i class="far fa-eye"></i></button>';
				}
				$arrData[$i]['options'] = '<div class="text-center">'.$btnView.' </div>';
			}
			echo json_encode($arrData,JSON_UNESCAPED_UNICODE);
		}
		die();
	}

	public function getProducto($idproducto){
		if($_SESSION['permisosMod']['r']){
			$idproducto = intval($idproducto);
			if($idproducto > 0){
				$arrData = $this->model->getProducto($idproducto);
				if(empty($arrData)){
					$arrResponse = array('status' => false, 'msg' => 'Datos no encontrados.');
				}else{
					$arrImg = $this->model->selectImages($idproducto);
					if(count($arrImg) > 0){
						for ($i=0; $i < count($arrImg); $i++) { 
							$arrImg[$i]['url_image'] = media().'/images/uploads/'.$arrImg[$i]['img'];
						}
					}
					$arrData['images'] = $arrImg;
					$arrResponse = array('status' => true, 'data' => $arrData);

					// dep($arrData);
					// exit;
				}
				echo json_encode($arrResponse,JSON_UNESCAPED_UNICODE);
			}
		}
		die();
	}

	public function addCarrito(){
		if($_POST){
			//unset($_SESSION['arrCarrito']);exit;
			$arrCarrito = array();
			$cantCarrito = 0;
			$idproducto = openssl_decrypt($_POST['id'], METHODENCRIPT, KEY);
			$cantidad = $_POST['cant'];
			if(is_numeric($idproducto) and is_numeric($cantidad)){
				$arrInfoProducto = $this->getProductoIDT($idproducto);
				// dep($arrInfoProducto);
				// exit;
				if(!empty($arrInfoProducto)){
					$arrProducto = array('idproducto' => $idproducto,
										'producto' => $arrInfoProducto['nombre'],
										'cantidad' => $cantidad,
										'precio' => $arrInfoProducto['precio'],
										'imagen' => $arrInfoProducto['images'][0]['url_image']
									);
					if(isset($_SESSION['arrCarrito'])){
						$on = true;
						$arrCarrito = $_SESSION['arrCarrito'];
						for ($pr=0; $pr < count($arrCarrito); $pr++) {
							if($arrCarrito[$pr]['idproducto'] == $idproducto){
								$arrCarrito[$pr]['cantidad'] += $cantidad;
								$on = false;
							}
						}
						if($on){
							array_push($arrCarrito,$arrProducto);
						}
						$_SESSION['arrCarrito'] = $arrCarrito;
					}else{
						array_push($arrCarrito, $arrProducto);
						$_SESSION['arrCarrito'] = $arrCarrito;
					}

					foreach ($_SESSION['arrCarrito'] as $pro) {
						$cantCarrito += $pro['cantidad'];
					}
					$htmlCarrito ="";
					$htmlCarrito = getFile('Template/Modals/modalCarrito',$_SESSION['arrCarrito']);
					$arrResponse = array("status" => true, 
										"msg" => '¡Se agrego al corrito!',
										"cantCarrito" => $cantCarrito,
										"htmlCarrito" => $htmlCarrito
									);

				}else{
					$arrResponse = array("status" => false, "msg" => 'Producto no existente.');
				}
			}else{
				$arrResponse = array("status" => false, "msg" => 'Dato incorrecto.');
			}
			echo json_encode($arrResponse,JSON_UNESCAPED_UNICODE);
		}
		die();
	}

	public function getSelectProductos(){
		$htmlOptions = "";
		$arrData = $this->model->selectProductos();
		if(count($arrData) > 0 ){
			for ($i=0; $i < count($arrData); $i++) { 
				if($arrData[$i]['status'] == 1 ){
				$htmlOptions .= '<option value="'.$arrData[$i]['idproducto'].'">'.$arrData[$i]['nombre'].'</option>';
				}
			}
		}
		echo $htmlOptions;
		die();	
	}

	public function categoria($params){
		if(empty($params)){
			header("Location:".base_url());
		}else{
			$categoria = strClean($params);
			$data['page_tag'] = NOMBRE_EMPESA." - ".$categoria;
			$data['page_title'] = $categoria;
			$data['page_name'] = "categoria";
			$data['productos'] = $this->getProductosCategoriaT($categoria);
			$this->views->getView($this,"categoria",$data);
		}
	}

	public function producto($params){
		if(empty($params)){
			header("Location:".base_url());
		}else{
			$producto = strClean($params);
			$arrProducto = $this->getProductoT($producto);
			$data['page_tag'] = NOMBRE_EMPESA." - ".$producto;
			$data['page_title'] = $producto;
			$data['page_name'] = "producto";
			$data['producto'] = $arrProducto;
			$data['productos'] = $this->getProductosRandom($arrProducto['categoriaid'],8,"r");
			$this->views->getView($this,"producto",$data);
		}
	}


}

?>